/*  Written by Julian Grizzard
 *  September 2, 2002
 *  Contact: gtg993j@mail.gatech.edu
 *
 *  Please contact me if you decide to publish any of this code.  Thanks!
 */


#include <stdio.h>
#include <stdlib.h>
#include "robot.h"
#include "world.h"

s_square *newSquare(int x, int y)
{
   s_square *newSquare = NULL;
   newSquare = (s_square *) malloc(sizeof(s_square));
   newSquare->x = x;
   newSquare->y = y;
   newSquare->paths = newList();
   return newSquare;
}

s_home *newHome()
{
   s_home *newHome = NULL;
   newHome = (s_home *) malloc(sizeof(s_home));
   newHome->x = 0;
   newHome->y = 0;
   return newHome;
}

s_pkg *newPkg()
{
   s_pkg *newPkg = NULL;
   newPkg = (s_pkg *) malloc(sizeof(s_pkg));
   newPkg->id = 0;
   newPkg->weight = 0;
   newPkg->xLoc = 0;
   newPkg->yLoc = 0;
   newPkg->x = 0;
   newPkg->y = 0;
   newPkg->state = P_GROUNDED;
   return newPkg;
}

s_pkg *findPkg(list *pkgL, int pkgID)
{
   element *finger = NULL;
   if(headElement(pkgL, &finger) < 0)
   {
      return NULL;
   }
   do
   {
      if(((s_pkg *)finger->value)->id == pkgID)
      {
         return (s_pkg *)finger->value;
      }
   } while(nextElement(pkgL, finger, &finger) == 0);
   return NULL;
}

