/*  Written by Julian Grizzard
 *  September 2, 2002
 *  Contact: gtg993j@mail.gatech.edu
 *
 *  Please contact me if you decide to publish any of this code.  Thanks!
 */


#ifndef _WORLD_H
#define _WORLD_H


/* constants */

#define P_GROUNDED 1
#define P_CARRIED 2

/* structs */
typedef struct s_world
{
   int width;      /* width of the world */
   int height;     /* height of world */
   char **map;     /* map of world */
} s_world;

/* define a square */
typedef struct s_square
{
   int x;   /* x location of square */
   int y;   /* y location of square */
   list *paths; /* list of paths that this square belongs to */
} s_square;

/* define a home */
typedef struct s_home
{
   int x;    /* x location of home base */
   int y;    /* y location of home base */
} s_home;

/* define the packages struct */
typedef struct s_pkg
{
   int id;              /* Packages id */
   int weight;          /* weight of packages */
   int xLoc;            /* x location */
   int yLoc;            /* y location */
   int x;               /* x destination */
   int y;               /* y destination */
   int state;           /* state of pkg, carried, grounded... */
} s_pkg;


/* Creates and returns a new home base
 * or NULL
 */
s_home *newHome();

/* Creates and returns a new home base
 * or NULL
 */
s_square *newSquare(int x, int y);


/* Creates and returns a new package
 * or NULL
 */
s_pkg *newPkg();

/* Find a package, given the package ID
 */
s_pkg *findPkg(list *pkgL, int pkgID);

#endif
